static void GsiDrawIndicator (void)
{
	Char indicatorChr;
	UInt32 GsiState;
	Coord     x;
	Coord     y;
	UInt32    _x;
	UInt32    _y;
	UInt32    enabled;
        SysNotifyParamType n;

	if ( errNone != FtrGet( MY_CRID, FTR_ENABLED, &enabled ) ||
	     ! enabled ||
             errNone != FtrGet( MY_CRID, FTR_GSI_STATE, &GsiState ) ||
	     errNone != FtrGet( MY_CRID, FTR_X, &_x ) ||
	     errNone != FtrGet( MY_CRID, FTR_Y, &_y ) )
	    return;

//        WinDrawChar( 'A'+GsiState, SysRandom(0)%120, SysRandom(0)%120);

       n.notifyType=sysNotifyGsiDrawIndicator;
       n.broadcaster=MY_CRID;
       n.notifyDetailsP=NULL;
       n.userDataP=0;
       n.handled=false;

       SysNotifyBroadcast(&n);

        x = ( UInt16 )_x;
        y = ( UInt16 )_y;

	switch (GsiState)
		{
		case gsiNumLock:				indicatorChr = symbolNumLock;		break;
		case gsiCapsLock:				indicatorChr = symbolCapsLock;	break;
		case gsiShiftPunctuation:	indicatorChr = symbolShiftPunc;	break;
		case gsiShiftExtended:		indicatorChr = symbolShiftExt;	break;
		case gsiShiftUpper:			indicatorChr = symbolShiftUpper;	break;
		case gsiShiftLower:			indicatorChr = symbolShiftUpper;	break;
                default:
  		case gsiShiftNone:			indicatorChr = symbolShiftNone;	break;
		}

		WinPushDrawState();
		FntSetFont (symbolFont);

		// assume background color is correct for window
		WinSetForeColor(UIColorGetTableEntryIndex(UIObjectForeground));
		WinSetCoordinateSystem( 72 );
		WinDrawChar (indicatorChr, x,y);
		WinPopDrawState();
}



