#include <Standalone.h>
#include "../Include/endianutils.h"
#include "../Include/palmos5.h"

#include "GSI_Res.h"

#define RESID RESID_GsiEnable

static void GsiDrawIndicator (void);

#define SWAP32( x ) ( ( ( x ) >> 24 ) | ( ( ( x ) & 0x00FF0000l ) >> 8 ) | ( ( ( x ) & 0x0000FF00l ) << 8 ) |  ( ( x ) << 24 ) )

STANDALONE_CODE_RESOURCE_TYPESTR_ID("armc", RESID);

typedef void (*pfnGsiEnable)( Boolean state );

void MyGsiEnable( Boolean state )
{
//    pfnGsiEnable oldTrap;

//    FtrGet(MY_CRID, RESID, (UInt32*) &oldTrap );

//    oldTrap( state );

    FtrSet( MY_CRID, FTR_ENABLED, state );

    if ( state )
        GsiDrawIndicator();
}


#include "GsiDrawIndicator.c"
