#include <Standalone.h>
#include "../Include/endianutils.h"
#include "../Include/palmos5.h"

#include "GSI_Res.h"

#define MODEL_GENERIC      0
#define MODEL_HAVE_NVFS    1
#define MODEL_MANUAL_FLUSH 2

#define RESID 999

#define SWAP32( x ) ( ( ( x ) >> 24 ) | ( ( ( x ) & 0x00FF0000l ) >> 8 ) | ( ( ( x ) & 0x0000FF00l ) << 8 ) |  ( ( x ) << 24 ) )

STANDALONE_CODE_RESOURCE_TYPESTR_ID("armc", RESID);

Boolean Activate( Boolean state )
{
    if ( state ) {
        FtrSet( MY_CRID, FTR_X, 0 );
        FtrSet( MY_CRID, FTR_Y, 0 );
        FtrSet( MY_CRID, FTR_ENABLED, 0 );
        FtrSet( MY_CRID, FTR_GSI_STATE, 0 );
    }
    else {
        FtrUnregister( MY_CRID, FTR_X );
        FtrUnregister( MY_CRID, FTR_Y );
        FtrUnregister( MY_CRID, FTR_ENABLED );
        FtrUnregister( MY_CRID, FTR_GSI_STATE );
    }
    return true;
}




